/*
	EZ-USB SmartMEdia[_C^[

	note:

	@RpC̓t[̃RpCAMINGWgpĂ܂B

	@̃vÓACypressЂ́udy|trap̊JLbgv
	IveB}CÝuJIUSBvp̐\tgx[XɎgpĂ
@@܂B


*/
#include <windows.h>
#include <stdio.h>

// MINGWWarning
#if !defined(_BYTE_DEFINED)
#define _BYTE_DEFINED
#define _WORD_DEFINED
#endif

// JItrap̔ėpCu
#include "cusb.h"
#include "gpfw.h"

//t@[EFAf[^̎荞
extern u8 fw_bin[];

#define TX_MAX 1024

// USBR}hpobt@
u8 buf[64];
// BurstWrtepobt@
u8 usb_buf[TX_MAX];
// gdwt@Cpobt@
u8 file_buffer[TX_MAX/8];

/* -------------------- EZ-USB interface -------------------- */

static HANDLE usb_h = NULL;

//CPIPE
void usb_cpipe_write(void *buf,DWORD size)
{
	usb_bulk_write(&usb_h,GPFW_CPIPE,buf,size);
}

//RPIPEǂݍ
void usb_rpipe_read(void *buf,DWORD size)
{
	usb_bulk_read(&usb_h,GPFW_RPIPE,buf,size);
}

//Fast WRITE f[^]
void usb_fwrite(u8 gpio,void *data,DWORD size)
{
	u8 cmd[4];

	cmd[0]=GPFW_BWRITE | (gpio&0x0f);
	cmd[1]=(u8)(size & 0x3f);
	cmd[2]=(u8)(size >> 6);
	cmd[3]=(u8)(size >> 14);
	usb_bulk_write(&usb_h,GPFW_CPIPE,cmd,4);
	usb_bulk_write(&usb_h,GPFW_WPIPE,data,size);
}

int ezusb_init(void)
{
	// EZ-USBhCõI[vƁAt@[EFÃ_E[h
	printf("Setup EZ-USB\n");
	if(cusb_init(0,&usb_h,fw_bin,"GPFW","V100"))
	{
		usb_h = NULL;
		printf("Can't found EZ-USB\n");
		return 2;
	}
	return 0;
}

void ezusb_end(void)
{
	if(usb_h)
		usb_close(&usb_h);
}


/* -------------------- SmartMEdia I/F -------------------- */

#define SM_CLE 0x01
#define SM_ALE 0x02
#define SM_CE  0x04
#define SM_VCC 0x08
#define SM_R_B 0x10
#define SM_WPS 0x20
#define SM_WP  0x40   /* T|[gAޏꍇAWPSM-VCCɌq */

#define SM_READ1   0x00
#define SM_READ2   0x01
#define SM_PGMDO   0x10 /* do program */
#define SM_DMYPGM  0x11 /* dummy program */
#define SM_MBPGM   0x15 /* multi block program */

#define SM_READ3   0x50
#define SM_PROGRAM 0x80 /* auto page program */
#define SM_ERASE   0x60 /* auto block erase */
#define SM_STATUS1 0x70
#define SM_STATUS2 0x71
#define SM_IDREAD1 0x90
#define SM_IDREAD2 0x91
#define SM_ERASEDO 0xf0 /* do erase   */
#define SM_RESET   0xff



//#define SM_DIR (SM_CLE|SM_ALE|SM_CE|SM_WP)
#define SM_DIR (SM_CLE|SM_ALE|SM_CE)

int sm_init(void)
{
	int c;

	if( ezusb_init() )
		return 1;

	c=0;
	buf[c++]=GPFW_DIR;
	buf[c++]=GPFW_SET | SM_CE;
	buf[c++]=GPFW_DIR | SM_DIR;
	buf[c++]=GPFW_BUS | 0x01;  // , streach=1
	buf[c++]= 0x12;            // RMOD = 10 , TMOD = 10
	buf[c++]=GPFW_GET | SM_CE; // check ditect 

	usb_cpipe_write(buf,c);
	usb_rpipe_read(buf,1);

	if(!(buf[0]&SM_VCC))
	{
		printf("No Media\n");
		return 1;
	}
#if 0
	// reset command
	c=0;
	buf[c++]=GPFW_WRITE | SM_CLE; // set CLE
	buf[c++]=0xff;                // reset command
	buf[c++]=GPFW_SET | SM_CE;    // end of read
	usb_cpipe_write(buf,c);
#endif
	return 0;
}

void sm_end(void)
{
	ezusb_end();
}

/* ID read command */
int sm_idread(BYTE *mfr,BYTE *dev,BYTE *op1,BYTE *op2,BYTE *ext)
{
	int c;

	/* ID read 1 */
	c=0;
	buf[c++]=GPFW_WRITE | SM_CLE; // set CLE
	buf[c++]=0x90;                // ID read2
	buf[c++]=GPFW_WRITE | SM_ALE; // set ALE
	buf[c++]=0x00;                // Address 00
	buf[c++]=GPFW_READ;           // data phase & read MFR
	buf[c++]=GPFW_READ;           // data phase & read DEV
	buf[c++]=GPFW_READ;           // data phase & read option1
	buf[c++]=GPFW_SET | SM_CE;    // end of read
	usb_cpipe_write(buf,c);
	usb_rpipe_read(buf,3);
	*mfr = buf[0];
	*dev = buf[1];
	*op1 = buf[2];
	*op2 = buf[2];

	if(*op2 == 0xc0)
	{
		/* ID read 2 */
		c=0;
		buf[c++]=GPFW_WRITE | SM_CLE; // set CLE
		buf[c++]=0x91;                // ID read2
		buf[c++]=GPFW_WRITE | SM_ALE; // set ALE
		buf[c++]=0x00;                // Address 00
		buf[c++]=GPFW_READ;           // data phase & read option1
		buf[c++]=GPFW_SET | SM_CE;    // end of read
		usb_cpipe_write(buf,c);
		usb_rpipe_read(buf,1);
		*ext = buf[0];
	}
	else
	{
		*ext = 0;
	}
	return 0;
}


/* -------------------- MAIN -------------------- */

// C
int main(int argc,char *argv[])
{
	DWORD file_size;
	char filename[128];
	DWORD file_pos,tx_size;
	int last_block;
	int i;

	int continus_mode,jtag_mode;
	int err;

	BYTE mfr,dev,op1,op2,ext;

	// ^Cg\
	printf("\n\
EZ-USB SmartMedia Reader/Writer\n\
Copyrght 2002 Tatsuuki Satoh\n");

#if 0
	// R}hC̉
	continus_mode = 0;
	jtag_mode = 1;
	filename[0] = 0x00;
	for( i=1 ; i<argc ; i++ )
	{
		if( argv[i][0] == '/' || argv[i][0] == '-')
		{
			// IvVXCb`
			switch( argv[i][1]|0x20 )
			{
			case 'c': continus_mode = 1; break;
			case 'j': jtag_mode = 1;     break;
			case 's': jtag_mode = 0;     break;
			}
		}
		else
		{
			// bitstreamt@C
			sprintf(filename,"%s.bit",argv[i]);
		}
	}

	if( filename[0] == 0)
	{
		printf("\nuseage: smrw\n");
		exit(1);
	}
#endif

	// v[u|[g̏ƁA^[Qbgd`FbN
	err = sm_init();
	if(err)
	{
		ezusb_end();
		exit(err);
	}

	sm_idread(&mfr,&dev,&op1,&op2,&ext);
	/* mfr 0x98==toshiba */
/*
	dev code
	98e6 = TC58V64BDC

	printf("Maker %02x , Device %02x , Opt1 %02x , Opt2 %02x , ext %02x\n"
		,mfr,dev,op1,op2,ext);


	//USBANZXI
	sm_end();
	exit(err);
}

